From 5cd8d61f9d01d92d71d254178614340804112fed Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 07 2020 00:18:44 +0000
Subject: [PATCH 107/2232] Implement returning Box from Rust to C++


---

diff --git a/gen/write.rs b/gen/write.rs
index f0bcaf9..7dc625e 100644
--- a/gen/write.rs
+++ b/gen/write.rs
@@ -336,8 +336,13 @@ fn write_rust_function_shim(out: &mut OutFile, efn: &ExternFn, types: &Types) {
             write!(out, "  ");
         } else if let Some(ret) = &efn.ret {
             write!(out, "return ");
-            if let Type::Ref(_) = ret {
-                write!(out, "*");
+            match ret {
+                Type::RustBox(_) => {
+                    write_type(out, ret);
+                    write!(out, "::from_raw(");
+                }
+                Type::Ref(_) => write!(out, "*"),
+                _ => {}
             }
         }
         for name in out.namespace.clone() {
@@ -368,7 +373,13 @@ fn write_rust_function_shim(out: &mut OutFile, efn: &ExternFn, types: &Types) {
             }
             write!(out, "&return$.value");
         }
-        writeln!(out, ");");
+        write!(out, ")");
+        if let Some(ret) = &efn.ret {
+            if let Type::RustBox(_) = ret {
+                write!(out, ")");
+            }
+        }
+        writeln!(out, ";");
         if indirect_return {
             writeln!(out, "  return ::std::move(return$.value);");
         }
diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index e21a62c..4c4f41c 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -36,7 +36,7 @@ pub mod ffi {
 
         fn r_return_primitive() -> usize;
         fn r_return_shared() -> Shared;
-        //TODO fn r_return_box() -> Box<R>;
+        fn r_return_box() -> Box<R>;
         //TODO fn r_return_unique_ptr() -> UniquePtr<C>;
         fn r_return_ref(shared: &Shared) -> &usize;
         fn r_return_str(shared: &Shared) -> &str;
@@ -65,6 +65,10 @@ fn r_return_shared() -> ffi::Shared {
     ffi::Shared { z: 2020 }
 }
 
+fn r_return_box() -> Box<R> {
+    Box::new(2020)
+}
+
 fn r_return_ref(shared: &ffi::Shared) -> &usize {
     &shared.z
 }
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 7b77c07..3d30ebe 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -102,6 +102,7 @@ extern "C" const char *cxx_run_test() noexcept {
 
   ASSERT(r_return_primitive() == 2020);
   ASSERT(r_return_shared().z == 2020);
+  ASSERT(cxx_test_suite_r_is_correct(&*r_return_box()));
   ASSERT(r_return_ref(Shared{2020}) == 2020);
   ASSERT(std::string(r_return_str(Shared{2020})) == "2020");
   ASSERT(std::string(r_return_rust_string()) == "2020");

